﻿Shader "CrispyPin/RaymarchOrigin"
{
	Properties
	{
		[Header(Raymarcher Properties)]
		_MaxSteps ("Max steps", Int) = 256
		_MaxDist ("Max distance", Float) = 100
		_SurfDist ("Surface distance threshold", Range(0.00001, 0.05)) = 0.001
	}
	SubShader
	{
		Tags { "RenderType"="Opaque" }
		Cull Off
		LOD 100
		Pass
		{
			// TODO: does this even do anything? its supposed to be on by default
			ZWrite On
			CGPROGRAM
			#pragma vertex vertex
			#pragma fragment fragment

			#define BASE_PASS
			#include "raymarcher.cginc"

			v2f vertex (appdata v){
				return vert(v);
			}

			fragOut fragment (v2f i) {
				return frag(i);
			}
			ENDCG
		}

		Pass
		{
			Tags { "LightMode" = "ForwardAdd"}
			ZWrite On
			CGPROGRAM
			#pragma vertex vertex
			#pragma fragment fragment

			#include "raymarcher.cginc"

			v2f vertex (appdata v){
				return vert(v);
			}

			fragOut fragment (v2f i) {
				return frag(i);
			}
			ENDCG
		}
	}
}
